' DeleteExZIP.VBA V1.03 (C) yoshioka.teruo@nifty.com 2008-06-26
' DeleteExZIP.VBA deletes ZIP file.

Option Explicit

Sub DeleteExZIP(ZIPfile As String, ParamArray Files() As Variant)
Dim fso As Object
Dim ie As Object
Dim Shell As Object
Dim zFolder As Object
Dim tFolderName As Variant
Dim tFolder As Object
Dim Path As Variant
Dim FileName As String
Dim zFolderItem As Object
Dim Count As Long

Set fso = CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(ZIPfile)) <> "ZIP" Then
  MsgBox "Invalid Extension Name - " & ZIPfile, vbCritical
  Exit Sub
End If
If Not fso.FileExists(ZIPfile) Then
  MsgBox "ZIP file not found. - " & ZIPfile, vbCritical
  Exit Sub
End If
ZIPfile = fso.GetAbsolutePathName(ZIPfile)
'IE7ȍ~
Set Shell = CreateObject("Shell.Application")
ZIPfile = Shell.Namespace((ZIPfile)).Self.Path
Shell.ShellExecute ZIPfile, , , , 0
Do
  For Each ie In Shell.Windows()
    If ie.Visible Then
    ElseIf InStr(TypeName(ie.Document), "IShellFolderViewDual") Then
      If ie.Document.Folder.Self.Path = ZIPfile Then Exit Do
    End If
  Next
  Application.Wait Now + TimeSerial(0, 0, 1)
Loop
'Set ie = CreateObject("InternetExplorer.Application")  'IE7ȍ~_
'Set ie = GetObject("new:{C08AFD90-F2A1-11D1-8455-00A0C91F3880}") 'IE7ȍ~
'ie.Navigate ZIPfile
Do While ie.Busy Or ie.ReadyState <> 4
  Application.Wait Now + TimeSerial(0, 0, 1)
Loop
Set Shell = ie.Document.Application
Set zFolder = ie.Document.Folder
tFolderName = fso.BuildPath(fso.GetParentFolderName(ZIPfile), fso.GetTempName())
fso.CreateFolder tFolderName
Set tFolder = Shell.Namespace(tFolderName)
For Each Path In Files
  FileName = fso.GetFileName(Path)
  Set zFolderItem = zFolder.ParseName(FileName)
  If zFolderItem Is Nothing Then
    MsgBox FileName & " - Not Found.", vbCritical
    Exit For
  End If
  Count = zFolder.Items().Count
'  tFolder.MoveHere zFolderItem
  zFolderItem.InvokeVerb "cut"
  tFolder.Self.InvokeVerb "paste"
  Do While zFolder.Items().Count = Count
'    WScript.Echo zFolder.Items().Count,Count
    Application.Wait Now + TimeSerial(0, 0, 1)
  Loop
Next
Set tFolder = Nothing
Set Shell = Nothing
ie.Quit
Do While TypeName(ie) = "IWebBrowser2"
  Application.Wait Now + TimeSerial(0, 0, 1)
Loop
'MsgBox "IE ended."
fso.DeleteFolder tFolderName
End Sub


Sub test1()
DeleteExZIP "a.zip", "a.txt"
End Sub

Sub test2()
DeleteExZIP "a.zip", "b.txt"
End Sub

Sub test3()
DeleteExZIP "a.txt", "a.txt"
End Sub
