' ListZIP.VBA V1.00 (C) yoshioka.teruo@nifty.com 2007-11-22
' ListZIP.VBA lists ZIP file contents.

Option Explicit

Function ListZIP(ZIPfile)
Dim fso As Object
Dim Shell As Object
Dim Folder As Object
Dim Rows
Dim k As Long
Dim Columns(8) As String
Dim FolderItem As Object

Rows = Array()
ListZIP = Rows
Set fso = CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(ZIPfile)) <> "ZIP" Then
  MsgBox "Invalid Extension Name - " & ZIPfile, vbCritical
  Exit Function
End If
If Not fso.FileExists(ZIPfile) Then
  MsgBox "ZIP file not found. - " & ZIPfile, vbCritical
  Exit Function
End If
Set Shell = CreateObject("Shell.Application")
Set Folder = Shell.Namespace(fso.GetAbsolutePathName(ZIPfile))
For k = 0 To UBound(Columns)
  Columns(k) = Folder.GetDetailsOf(, k)
Next
Push Rows, Columns
For Each FolderItem In Folder.Items()
  For k = 0 To UBound(Columns)
    If k = 5 Then
      Columns(k) = FolderItem.Size
    Else
      Columns(k) = Folder.GetDetailsOf(FolderItem, k)
    End If
  Next
  Push Rows, Columns
Next
ListZIP = Rows
End Function

Sub Push(Items, Item)
ReDim Preserve Items(UBound(Items) + 1)
Items(UBound(Items)) = Item
End Sub

Sub test1()
Dim a
Dim k
a = ListZIP("a.zip")
Debug.Print UBound(a)
For k = 0 To UBound(a)
  Debug.Print Join(a(k), vbTab)
Next
End Sub

Sub test2()
Dim a
a = ListZIP("b.zip")
Debug.Print UBound(a)
End Sub
