' DeleteZIP.VBA V1.00 (C) yoshioka.teruo@nifty.com 2007-11-22
' DeleteZIP.VBA deletes ZIP file.

Option Explicit

Sub DeleteZIP(ZIPfile As String, ParamArray Files() As Variant)
Dim fso As Object
Dim Shell As Object
Dim Folder As Object
Dim FileName As Variant
Dim FolderItem As Object

Set fso = CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(ZIPfile)) <> "ZIP" Then
  MsgBox "Invalid Extension Name - " & ZIPfile, vbCritical
  Exit Sub
End If
If Not fso.FileExists(ZIPfile) Then
  MsgBox "ZIP file not found. - " & ZIPfile, vbCritical
  Exit Sub
End If
Set Shell = CreateObject("Shell.Application")
Set Folder = Shell.Namespace(fso.GetAbsolutePathName(ZIPfile))
For Each FileName In Files
  Set FolderItem = Folder.ParseName(FileName)
  If FolderItem Is Nothing Then
    MsgBox FileName & " - Not Found.", vbCritical
    Exit For
  End If
  FolderItem.InvokeVerb ("delete")
'  FolderItem.InvokeVerb ("폜(&D)")
Next
End Sub

Sub test1()
DeleteZIP "a.zip", "a.txt"
End Sub

Sub test2()
DeleteZIP "a.zip", "b.txt"
End Sub

Sub test3()
DeleteZIP "a.txt", "a.txt"
End Sub


