' MakeExZIP.VBA V1.03 (C) yoshioka.teruo@nifty.com 2008-06-26
' MakeExZIP.VBA makes ZIP file.

Option Explicit

Sub MakeExZIP(ZIPfile As String, ParamArray Files() As Variant)
Dim fso As Object
Dim ie As Object
Dim Shell As Object
Dim zFolder As Object
Dim Path As Variant
Dim FileName As Variant
Dim zFolderItem As Object
Dim tFolderName As Variant
Dim tFolder As Object
Dim sFolderItem As Object
Dim Count As Long

Set fso = CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(ZIPfile)) <> "ZIP" Then
  MsgBox "Invalid Extension Name - " & ZIPfile, vbCritical
  Exit Sub
End If
ZIPfile = fso.GetAbsolutePathName(ZIPfile)
If fso.FileExists(ZIPfile) Then
'IE7ȍ~
Set Shell = CreateObject("Shell.Application")
ZIPfile = Shell.Namespace((ZIPfile)).Self.Path
Shell.ShellExecute ZIPfile, , , , 0
Do
  For Each ie In Shell.Windows()
    If ie.Visible Then
    ElseIf InStr(TypeName(ie.Document), "IShellFolderViewDual") Then
      If ie.Document.Folder.Self.Path = ZIPfile Then Exit Do
    End If
  Next
  Application.Wait Now + TimeSerial(0, 0, 1)
Loop
'Set ie = CreateObject("InternetExplorer.Application")  'IE7ȍ~_
'Set ie = GetObject("new:{C08AFD90-F2A1-11D1-8455-00A0C91F3880}") 'IE7ȍ~
'ie.Navigate ZIPfile
  Do While ie.Busy Or ie.ReadyState <> 4
    Application.Wait Now + TimeSerial(0, 0, 1)
  Loop
  Set Shell = ie.Document.Application
  Set zFolder = ie.Document.Folder
Else
  fso.CreateTextFile(ZIPfile, False).Write "PK" & Chr(5) & Chr(6) & String(18, 0)
  Set Shell = CreateObject("Shell.Application")
  Set zFolder = Shell.Namespace(ZIPfile)
End If
For Each Path In Files
  FileName = fso.GetFileName(Path)
  Set sFolderItem = Shell.Namespace(fso.GetAbsolutePathName(Path) & "\..\").Items().Item(FileName)
  If sFolderItem Is Nothing Then
    MsgBox Path & " - Not Found.", vbCritical
    Exit For
  End If
  Set zFolderItem = zFolder.ParseName(FileName)
  If Not zFolderItem Is Nothing Then
    If IsEmpty(tFolderName) Then
      tFolderName = fso.BuildPath(fso.GetParentFolderName(ZIPfile), fso.GetTempName())
      fso.CreateFolder tFolderName
      Set tFolder = Shell.Namespace(tFolderName)
    End If
    Count = zFolder.Items().Count
'    tFolder.MoveHere zFolderItem
    zFolderItem.InvokeVerb "cut"
    tFolder.Self.InvokeVerb "paste"
    Do While zFolder.Items().Count = Count
'      WScript.Echo 2,zFolder.Items().Count,Count
      Application.Wait Now + TimeSerial(0, 0, 1)
    Loop
  End If
  Count = zFolder.Items().Count
  zFolder.CopyHere sFolderItem
  Do While zFolder.Items().Count = Count
'    WScript.Echo 3,zFolder.Items().Count,Count
    Application.Wait Now + TimeSerial(0, 0, 1)
  Loop
Next
Set tFolder = Nothing
Set Shell = Nothing
If Not IsEmpty(ie) Then ie.Quit
Do While TypeName(ie) = "IWebBrowser2"
  Application.Wait Now + TimeSerial(0, 0, 1)
Loop
'MsgBox "IE ended."
If Not IsEmpty(tFolderName) Then
  fso.DeleteFolder tFolderName
End If

End Sub

Sub test1()
MakeExZIP "a.zip", "a.txt"
End Sub

Sub test2()
MakeExZIP "a.zip", "b.txt"
End Sub

Sub test3()
MakeExZIP "a.txt", "a.txt"
End Sub
